import { defineComponent as N, ref as y, watch as P, computed as j, provide as F, openBlock as H, createBlock as I, resolveDynamicComponent as T, mergeProps as A } from "vue";
import { deepCloneJSON as u, get as M, set as Y } from "@codeperate/utils";
import { debounce as J } from "./utils/debounce.utils.js";
import { LocalStorage as h } from "./utils/localstorage.util.js";
const Q = /* @__PURE__ */ N({
  __name: "FormBuilder",
  props: {
    schema: {},
    view: { type: Boolean, default: !1 },
    disabled: { type: Boolean },
    value: {},
    saveLocation: {},
    saveExpiry: { default: 1e3 * 60 * 60 * 24 },
    saveDelay: { default: 5e3 },
    autoSave: { type: Boolean, default: !1 }
  },
  emits: ["change", "update:value"],
  setup(V, { expose: x, emit: B }) {
    const s = V, v = B, c = /* @__PURE__ */ new Map(), p = y(0), n = y(u(s.value));
    P(
      () => s.value,
      () => n.value = u(s.value)
    );
    const S = (e = {}) => {
      var i, a;
      Object.assign(e, {
        scrollToInvalidWidget: !0
      });
      const t = l().filter((r) => !r.isHidden()).map((r) => r.validate()).filter((r) => r);
      if (e.scrollToInvalidWidget) {
        let r = t.find((d) => (d == null ? void 0 : d.validity) == !1);
        r && ((a = (i = l(r.path)[0].el) == null ? void 0 : i.value) == null || a.scrollIntoView({
          behavior: "smooth",
          block: "center",
          inline: "center"
        }));
      }
      return t;
    }, b = (e = "") => {
      l(e).forEach((t) => t.undoValidate());
    }, L = (e, o) => {
      const t = c.get(e);
      if (!t)
        c.set(e, [o]), p.value += 1;
      else {
        if (t.find((a) => a === o)) return;
        t.push(o), p.value += 1;
      }
    }, O = (e, o) => {
      const t = c.get(e);
      if (!t) return;
      t.find((a) => a === o) && c.set(
        e,
        t.filter((a) => a !== o)
      );
    }, l = (e = "") => {
      const o = typeof e == "string" ? e : e.join("."), t = [];
      for (const [i, a] of c.entries())
        i.startsWith(o) && t.push(...a);
      return t;
    }, _ = () => s.view, m = (e) => M(n.value, e), g = (e = "", o) => {
      typeof e == "string" && (e = e.split(".").filter((t) => t)), e.length == 0 ? n.value = o : (n.value == null && (isNaN(Number(e[0])) ? n.value = {} : n.value = []), Y(n.value, e, o)), v("change", n.value), v("update:value", n.value), s.autoSave && C();
    }, E = (e) => {
      n.value = e(n);
    }, W = (e) => {
      typeof e == "string" && (e = e.split(".").filter((t) => t));
      let o = s.schema;
      if (!e) return o;
      for (const t of e)
        if (o != null && o.properties && t in o.properties) o = o.properties[t];
        else if (o.items) o = o.items;
        else return {};
      return o;
    }, k = async (e = {}) => {
      e = Object.assign({
        removeAdditional: !0
      }, e);
      let t = { value: u(n.value) };
      const i = l(), a = [];
      for (const r of i) a.push(r.onExportValue(t, e));
      return await Promise.all(a), t.value;
    }, w = async () => {
      if (!s.saveLocation) throw new Error("You must define save location first.");
      try {
        const e = u(m()), o = l(), t = [];
        for (const i of o) t.push(i.onSaveHistory(e));
        await Promise.all(t), h.set(s.saveLocation, {
          value: e,
          expiryAt: (/* @__PURE__ */ new Date()).getTime() + s.saveExpiry
        });
      } catch {
      }
    }, C = J(w, s.saveDelay), f = {
      formValue: n,
      exportValue: k,
      regWidget: L,
      unRegWidget: O,
      getWidgets: l,
      getValue: m,
      setValue: g,
      setValueByFn: E,
      getSchema: W,
      getView: _,
      validate: S,
      undoValidate: b,
      save: w,
      load: async () => {
        if (!s.saveLocation) throw new Error("You must define save location first.");
        const e = h.get(s.saveLocation), o = l(), t = [];
        for (const i of o) t.push(i.onLoadHistory(e.value));
        await Promise.all(t), g("", e.value);
      }
    }, D = j(() => {
      let e = s.schema.props ?? {};
      return typeof e == "function" ? e({ form: f }) : e;
    });
    return F("formBuilder", f), x(f), (e, o) => {
      var t;
      return H(), I(T((t = s.schema.widget) == null ? void 0 : t.component), A({ path: "" }, D.value), null, 16);
    };
  }
});
export {
  Q as default
};
