/* __placeholder__ */
import { ref } from 'vue';
import { useConfig } from '../config';
import { useEnum } from '../enum';
import { useFormWidget } from './FormWidget';
const { defineProps, defineSlots, defineEmits, defineExpose, defineModel, defineOptions, withDefaults, } = await import('vue');
const el = ref();
let __VLS_typeProps;
const props = withDefaults(defineProps(), useConfig('CheckBoxWidget', {
    empty: 'N/A',
    minItems: 0,
    selectAllText: 'Select All',
    deselectAllText: 'Deselect All',
}));
const { mappedEnum } = useEnum(props);
const { value, isRequired, setValue, register, validatedMeta, validator: defaultValidator, validate, view, isValid, } = useFormWidget('CheckBoxWidget', props);
if (value.value == null)
    setValue([]);
const validator = () => {
    defaultValidator();
    if (props.minItems != null && value.value.length < props.minItems) {
        validatedMeta.value.validity = false;
        validatedMeta.value.err ??= [{ msg: `Minimum ${props.minItems} items required` }];
    }
    else if (props.maxItems != null && value.value.length > props.maxItems) {
        validatedMeta.value.validity = false;
        validatedMeta.value.err ??= [{ msg: `Maximum ${props.maxItems} items allowed` }];
    }
    else if (isRequired() && value.value.length === 0) {
        validatedMeta.value.validity = false;
        validatedMeta.value.err ??= [{ msg: 'Required' }];
    }
    return validatedMeta.value;
};
const checkHandler = (key) => {
    const exist = value.value.includes(key);
    if (exist)
        setValue(value.value.filter(v => v !== key));
    else
        setValue([...value.value, key]);
    validate();
};
const selectAll = () => {
    setValue(Object.keys(mappedEnum.value));
    validate();
};
const deselectAll = () => {
    setValue([]);
    validate();
};
register({ validator, el });
const __VLS_withDefaultsArg = (function (t) { return t; })(useConfig('CheckBoxWidget', {
    empty: 'N/A',
    minItems: 0,
    selectAllText: 'Select All',
    deselectAllText: 'Deselect All',
}));
const __VLS_fnComponent = (await import('vue')).defineComponent({});
let __VLS_functionalComponentProps;
function __VLS_template() {
    let __VLS_ctx;
    /* Components */
    let __VLS_otherComponents;
    let __VLS_own;
    let __VLS_localComponents;
    let __VLS_components;
    let __VLS_styleScopedClasses;
    let __VLS_resolvedLocalAndGlobalComponents;
    if (__VLS_ctx.view) {
        (__VLS_ctx.value.join(','));
        // @ts-ignore
        [view, value,];
    }
    else {
        __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ref: ("el"), ...{ class: (([
                    'cfb-grid cfb-gap-2 cfb-p-2 cfb-rounded-lg',
                    {
                        'cfb-bg-danger-100': __VLS_ctx.isValid() == false,
                    },
                ])) }, });
        // @ts-ignore
        (__VLS_ctx.el);
        __VLS_styleScopedClasses = ([
            'cfb-grid cfb-gap-2 cfb-p-2 cfb-rounded-lg',
            {
                'cfb-bg-danger-100': isValid() == false,
            },
        ]);
        __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ class: ("cfb-flex cfb-flex-wrap cfb-gap-4") }, });
        __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ class: ("cfb-flex cfb-gap-2 cfb-items-center") }, });
        for (const [label, enumKey] of __VLS_getVForSourceType((__VLS_ctx.mappedEnum))) {
            __VLS_elementAsFunction(__VLS_intrinsicElements.label, __VLS_intrinsicElements.label)({ for: ((`${__VLS_ctx.widgetId ?? __VLS_ctx.path}-${enumKey}`)), ...{ class: ("cfb-border-main-500 cfb-flex cfb-items-center cfb-gap-2 cfb-border cfb-rounded-lg cfb-px-2 cfb-py-1 cfb-min-w-28") }, });
            __VLS_elementAsFunction(__VLS_intrinsicElements.input)({ ...{ onClick: (...[$event]) => {
                        if (!(!((__VLS_ctx.view))))
                            return;
                        __VLS_ctx.checkHandler(enumKey);
                        // @ts-ignore
                        [isValid, el, mappedEnum, widgetId, path, checkHandler,];
                    } }, id: ((`${__VLS_ctx.widgetId ?? __VLS_ctx.path}-${enumKey}`)), ...{ class: ("cfb-size-4") }, type: ("checkbox"), value: ((enumKey)), checked: ((__VLS_ctx.value.includes(enumKey))), });
            // @ts-ignore
            [value, widgetId, path,];
            __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({});
            (label);
        }
        __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ class: ("cfb-flex cfb-gap-2") }, });
        __VLS_elementAsFunction(__VLS_intrinsicElements.button, __VLS_intrinsicElements.button)({ ...{ onClick: (__VLS_ctx.selectAll) }, ...{ class: ("cfb-bg-main-600 cfb-text-white cfb-px-2 cfb-py-1 cfb-rounded-lg cfb-text-sm") }, });
        (__VLS_ctx.selectAllText);
        // @ts-ignore
        [selectAll, selectAllText,];
        __VLS_elementAsFunction(__VLS_intrinsicElements.button, __VLS_intrinsicElements.button)({ ...{ onClick: (__VLS_ctx.deselectAll) }, ...{ class: ("cfb-bg-main-600 cfb-text-white cfb-px-2 cfb-py-1 cfb-rounded-lg cfb-text-sm") }, });
        (__VLS_ctx.deselectAllText);
        // @ts-ignore
        [deselectAll, deselectAllText,];
        if (__VLS_ctx.validatedMeta?.err?.[0].msg) {
            __VLS_elementAsFunction(__VLS_intrinsicElements.span, __VLS_intrinsicElements.span)({ ...{ class: ("cfb-mt-1 cfb-text-sm cfb-text-danger-600") }, });
            (__VLS_ctx.validatedMeta.err[0].msg);
            // @ts-ignore
            [validatedMeta, validatedMeta,];
        }
    }
    if (typeof __VLS_styleScopedClasses === 'object' && !Array.isArray(__VLS_styleScopedClasses)) {
        __VLS_styleScopedClasses['cfb-flex'];
        __VLS_styleScopedClasses['cfb-flex-wrap'];
        __VLS_styleScopedClasses['cfb-gap-4'];
        __VLS_styleScopedClasses['cfb-flex'];
        __VLS_styleScopedClasses['cfb-gap-2'];
        __VLS_styleScopedClasses['cfb-items-center'];
        __VLS_styleScopedClasses['cfb-border-main-500'];
        __VLS_styleScopedClasses['cfb-flex'];
        __VLS_styleScopedClasses['cfb-items-center'];
        __VLS_styleScopedClasses['cfb-gap-2'];
        __VLS_styleScopedClasses['cfb-border'];
        __VLS_styleScopedClasses['cfb-rounded-lg'];
        __VLS_styleScopedClasses['cfb-px-2'];
        __VLS_styleScopedClasses['cfb-py-1'];
        __VLS_styleScopedClasses['cfb-min-w-28'];
        __VLS_styleScopedClasses['cfb-size-4'];
        __VLS_styleScopedClasses['cfb-flex'];
        __VLS_styleScopedClasses['cfb-gap-2'];
        __VLS_styleScopedClasses['cfb-bg-main-600'];
        __VLS_styleScopedClasses['cfb-text-white'];
        __VLS_styleScopedClasses['cfb-px-2'];
        __VLS_styleScopedClasses['cfb-py-1'];
        __VLS_styleScopedClasses['cfb-rounded-lg'];
        __VLS_styleScopedClasses['cfb-text-sm'];
        __VLS_styleScopedClasses['cfb-bg-main-600'];
        __VLS_styleScopedClasses['cfb-text-white'];
        __VLS_styleScopedClasses['cfb-px-2'];
        __VLS_styleScopedClasses['cfb-py-1'];
        __VLS_styleScopedClasses['cfb-rounded-lg'];
        __VLS_styleScopedClasses['cfb-text-sm'];
        __VLS_styleScopedClasses['cfb-mt-1'];
        __VLS_styleScopedClasses['cfb-text-sm'];
        __VLS_styleScopedClasses['cfb-text-danger-600'];
    }
    var __VLS_slots;
    return __VLS_slots;
    const __VLS_componentsOption = {};
    let __VLS_name;
    let __VLS_defineComponent;
    const __VLS_internalComponent = __VLS_defineComponent({
        setup() {
            return {
                el: el,
                mappedEnum: mappedEnum,
                value: value,
                validatedMeta: validatedMeta,
                view: view,
                isValid: isValid,
                checkHandler: checkHandler,
                selectAll: selectAll,
                deselectAll: deselectAll,
            };
        },
        props: {},
    });
}
export default (await import('vue')).defineComponent({
    setup() {
        return {};
    },
    props: {},
});
;
