/* __placeholder__ */
import { computed, ref } from 'vue';
import { useFormWidget } from './FormWidget';
import { useConfig } from '../config';
const { defineProps, defineSlots, defineEmits, defineExpose, defineModel, defineOptions, withDefaults, } = await import('vue');
let __VLS_typeProps;
const props = withDefaults(defineProps(), useConfig('PasswordWidget', {
    empty: 'N/A',
    mask: '••••••••••••',
}));
const inputEl = ref();
const showPW = ref(false);
const { value, isRequired, setValue, register, validatedMeta, validator: defaultValidator, validate, isValid, view, } = useFormWidget('PasswordWidget', props);
const validator = () => {
    let el = inputEl.value;
    defaultValidator();
    if (el) {
        validatedMeta.value.validity = el.checkValidity();
        if (el.validationMessage)
            validatedMeta.value.err ??= [{ msg: el.validationMessage }];
    }
    return validatedMeta.value;
};
register({ validator, el: inputEl });
const inputHandler = (e) => {
    if (e.target.value === '')
        setValue(undefined);
    else
        setValue(e.target.value);
    validate();
};
const pattern = computed(() => {
    if (props.pattern instanceof RegExp)
        return props.pattern.source;
    else
        return props.pattern;
});
const __VLS_withDefaultsArg = (function (t) { return t; })(useConfig('PasswordWidget', {
    empty: 'N/A',
    mask: '••••••••••••',
}));
const __VLS_fnComponent = (await import('vue')).defineComponent({});
let __VLS_functionalComponentProps;
function __VLS_template() {
    let __VLS_ctx;
    /* Components */
    let __VLS_otherComponents;
    let __VLS_own;
    let __VLS_localComponents;
    let __VLS_components;
    let __VLS_styleScopedClasses;
    let __VLS_resolvedLocalAndGlobalComponents;
    if (__VLS_ctx.view) {
        __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ class: ("cfb-flex cfb-justify-between cfb-w-full") }, });
        __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({});
        (__VLS_ctx.showPW ? __VLS_ctx.value ?? __VLS_ctx.empty : __VLS_ctx.mask);
        // @ts-ignore
        [view, showPW, value, empty, mask,];
        __VLS_elementAsFunction(__VLS_intrinsicElements.button, __VLS_intrinsicElements.button)({ ...{ onClick: (...[$event]) => {
                    if (!((__VLS_ctx.view)))
                        return;
                    __VLS_ctx.showPW = !__VLS_ctx.showPW;
                    // @ts-ignore
                    [showPW, showPW,];
                } }, type: ("button"), ...{ class: ("cfb-aspect-square cfb-w-7 cfb-rounded-lg hover:cfb-bg-gray-400") }, });
        __VLS_elementAsFunction(__VLS_intrinsicElements.i, __VLS_intrinsicElements.i)({ ...{ class: ((['fa-solid', __VLS_ctx.showPW ? 'fa-eye' : 'fa-eye-slash'])) }, });
        __VLS_styleScopedClasses = (['fa-solid', showPW ? 'fa-eye' : 'fa-eye-slash']);
        // @ts-ignore
        [showPW,];
    }
    else {
        __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ class: (([
                    'cfb-items-center cfb-flex cfb-pr-1 cfb-rounded-lg cfb-min-w-0 cfb-w-full cfb-appearance-none',
                    {
                        'cfb-bg-valid-100 hover:cfb-bg-valid-200': __VLS_ctx.isValid() == true,
                        'cfb-bg-danger-100 hover:cfb-bg-danger-200': __VLS_ctx.isValid() == false,
                        'cfb-bg-gray-200 hover:cfb-bg-gray-300': __VLS_ctx.isValid() == undefined,
                    },
                ])) }, });
        __VLS_styleScopedClasses = ([
            'cfb-items-center cfb-flex cfb-pr-1 cfb-rounded-lg cfb-min-w-0 cfb-w-full cfb-appearance-none',
            {
                'cfb-bg-valid-100 hover:cfb-bg-valid-200': isValid() == true,
                'cfb-bg-danger-100 hover:cfb-bg-danger-200': isValid() == false,
                'cfb-bg-gray-200 hover:cfb-bg-gray-300': isValid() == undefined,
            },
        ]);
        __VLS_elementAsFunction(__VLS_intrinsicElements.input)({ ...{ onInput: (__VLS_ctx.inputHandler) }, required: ((__VLS_ctx.isRequired())), ...{ class: ("cfb-flex-grow cfb-bg-opacity-0 cfb-bg-white cfb-p-1.5 cfb-rounded-lg focus:cfb-outline-none cfb-w-full cfb-appearance-none") }, type: ((__VLS_ctx.showPW ? 'text' : 'password')), value: ((__VLS_ctx.value || '')), minlength: ((__VLS_ctx.minLength)), maxlength: ((__VLS_ctx.maxLength)), pattern: ((__VLS_ctx.pattern)), ref: ("inputEl"), id: ((__VLS_ctx.widgetId ?? __VLS_ctx.path)), });
        // @ts-ignore
        (__VLS_ctx.inputEl);
        // @ts-ignore
        [showPW, value, isValid, isValid, isValid, inputHandler, isRequired, minLength, maxLength, pattern, widgetId, path, inputEl,];
        __VLS_elementAsFunction(__VLS_intrinsicElements.button, __VLS_intrinsicElements.button)({ ...{ onClick: (...[$event]) => {
                    if (!(!((__VLS_ctx.view))))
                        return;
                    __VLS_ctx.showPW = !__VLS_ctx.showPW;
                    // @ts-ignore
                    [showPW, showPW,];
                } }, type: ("button"), ...{ class: ("cfb-aspect-square cfb-w-7 cfb-rounded-lg hover:cfb-bg-gray-400") }, });
        __VLS_elementAsFunction(__VLS_intrinsicElements.i, __VLS_intrinsicElements.i)({ ...{ class: ((['fa-solid', __VLS_ctx.showPW ? 'fa-eye' : 'fa-eye-slash'])) }, });
        __VLS_styleScopedClasses = (['fa-solid', showPW ? 'fa-eye' : 'fa-eye-slash']);
        // @ts-ignore
        [showPW,];
        if (__VLS_ctx.validatedMeta?.err?.[0].msg) {
            __VLS_elementAsFunction(__VLS_intrinsicElements.span, __VLS_intrinsicElements.span)({ ...{ class: ("cfb-mt-1 cfb-text-sm cfb-text-danger-600") }, });
            (__VLS_ctx.validatedMeta.err[0].msg);
            // @ts-ignore
            [validatedMeta, validatedMeta,];
        }
    }
    if (typeof __VLS_styleScopedClasses === 'object' && !Array.isArray(__VLS_styleScopedClasses)) {
        __VLS_styleScopedClasses['cfb-flex'];
        __VLS_styleScopedClasses['cfb-justify-between'];
        __VLS_styleScopedClasses['cfb-w-full'];
        __VLS_styleScopedClasses['cfb-aspect-square'];
        __VLS_styleScopedClasses['cfb-w-7'];
        __VLS_styleScopedClasses['cfb-rounded-lg'];
        __VLS_styleScopedClasses['hover:cfb-bg-gray-400'];
        __VLS_styleScopedClasses['cfb-flex-grow'];
        __VLS_styleScopedClasses['cfb-bg-opacity-0'];
        __VLS_styleScopedClasses['cfb-bg-white'];
        __VLS_styleScopedClasses['cfb-p-1.5'];
        __VLS_styleScopedClasses['cfb-rounded-lg'];
        __VLS_styleScopedClasses['focus:cfb-outline-none'];
        __VLS_styleScopedClasses['cfb-w-full'];
        __VLS_styleScopedClasses['cfb-appearance-none'];
        __VLS_styleScopedClasses['cfb-aspect-square'];
        __VLS_styleScopedClasses['cfb-w-7'];
        __VLS_styleScopedClasses['cfb-rounded-lg'];
        __VLS_styleScopedClasses['hover:cfb-bg-gray-400'];
        __VLS_styleScopedClasses['cfb-mt-1'];
        __VLS_styleScopedClasses['cfb-text-sm'];
        __VLS_styleScopedClasses['cfb-text-danger-600'];
    }
    var __VLS_slots;
    return __VLS_slots;
    const __VLS_componentsOption = {};
    let __VLS_name;
    let __VLS_defineComponent;
    const __VLS_internalComponent = __VLS_defineComponent({
        setup() {
            return {
                inputEl: inputEl,
                showPW: showPW,
                value: value,
                isRequired: isRequired,
                validatedMeta: validatedMeta,
                isValid: isValid,
                view: view,
                inputHandler: inputHandler,
                pattern: pattern,
            };
        },
        props: {},
    });
}
export default (await import('vue')).defineComponent({
    setup() {
        return {};
    },
    props: {},
});
;
